package ssc.groups1

import no.prpr.security.Role
import no.prpr.security.RoleGroup
import no.prpr.security.RoleGroupRole
import no.prpr.security.User
import no.prpr.security.UserRoleGroup

class BootStrap {

    def init = { servletContext ->
        def adminUser = User.findByUsername('admin')
        if (!adminUser) {
            User.withNewTransaction {
                adminUser = new User(username: 'admin', password: 'password')
                        .save(flush: true)
            }
            log.info("Added user admin: ${adminUser}")
        }

        def adminsRoleGroup = RoleGroup.findByName('Admins')
        if (!adminsRoleGroup) {
            RoleGroup.withNewTransaction {
                adminsRoleGroup = new RoleGroup(name: 'Admins')
                        .save(flush: true)
            }
            log.info("Added role-group Admins: ${adminsRoleGroup}")
        }

        def adminRole = Role.findByAuthority('ROLE_ADMIN')
        if (!adminRole) {
            Role.withNewTransaction {
                adminRole = new Role(authority: 'ROLE_ADMIN')
                adminRole.save(flush: true)
            }
            log.info("Added role ROLE_ADMIN: ${adminRole}")
        }

        def adminsToAdminRoleGroup = RoleGroupRole.get(adminsRoleGroup.id, adminRole.id)
        if (!adminsToAdminRoleGroup) {
            RoleGroupRole.withNewTransaction {
                adminsToAdminRoleGroup = new RoleGroupRole(roleGroup: adminsRoleGroup, role: adminRole)
                        .save(flush: true)
            }
            log.info("Added admin role to admins role-group -> adminsToAdminRoleGroup: ${adminsToAdminRoleGroup}")
        }

        def adminsUserRoleGroup = UserRoleGroup.get(adminUser.id, adminsRoleGroup.id)
        if (!adminsUserRoleGroup) {
            UserRoleGroup.withNewTransaction {
                adminsUserRoleGroup = new UserRoleGroup(user: adminUser, roleGroup: adminsRoleGroup)
                        .save(flush: true)
            }
            log.info("added admin to admins-role-group -> adminsUserRoleGroup: ${adminsUserRoleGroup}")
        }
    }
    def destroy = {
    }
}